Subject: Re: SPARSE files considered harmful - please revert
From: Martin Buchholz <[email-masked]>
To: "Max Bowsher" <[email-masked]>
Cc: <[email-masked]>
Date: Sun, 18 May 2003 16:56:15 -0700

>>>>> "Max" == Max Bowsher <[email-masked]> writes:

Max> Martin Buchholz wrote:
>> As a result, a non-empty but small sparse file takes up a minimum of
>> 16*clustersize bytes on the disk.  My measurements suggest an overhead
>> of 32kb per file with a cluster size of 4kb.

Max> I just thought I'd throw a few more numbers into the debate:

Max> I patched Cygwin to respond to CYGWIN=sparse / CYGWIN=nosparse
Max> Then, I did a cvs co winsup:

Max> "Size on disc" of checked out dir, as shown in Windows properties box:
Max> Sparse: 40.7MB
Max> Not sparse: 43.6MB
Max> OK, so sparse seems to win? But that makes no sense - backed up by noting
Max> that for various individual sparse files, "Size on disc" is reporting a size
Max> which is not an integer number of clusters.

Max> Now, Properties of disc, look at "Used space":
Max> Difference in creating sparse checkout: ~ 200MB !!!
Max> Difference in creating normal checkout: ~  40MB

This 5-fold expansion is just like what I saw.

Max> Personally, I'm inclined to trust the overall disc stats more.

The thing that matters is, what happens when the disk gets to 100%?
This did happen to me.  I do not recall getting any "disk full" error
messages, but the disk was unhappy nevertheless.  Processes writing to
the disk would tend to hang.

Max> I think this evidence suggests that sparse files should NOT be on by default
Max> in Cygwin.

Yup.

Martin

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/